#define L0ENKODER A4
#define L1ENKODER A5
#define P1ENKODER A6
#define P0ENKODER A7

#define P0MOTOR 9
#define P1MOTOR 10
#define L0MOTOR 5
#define L1MOTOR 6

#define PCIDLO A0
#define LCIDLO A1

#define PRAHENKODER 50

char pStav = 0;
char pStavMinuly = 0;
int counter = 0;

int P1MAX = 0, P0MAX = 0, L1MAX = 0, L0MAX = 0, PCIDLOMAX = 0, LCIDLOMAX = 0;
int P1MIN = 1023, P0MIN = 1023, L1MIN = 1023, L0MIN = 1023, PCIDLOMIN = 1023, LCIDLOMIN = 1023;

void setup() {
  // put your setup code here, to run once:
  pinMode(L0ENKODER, INPUT);
  pinMode(L1ENKODER, INPUT);
  pinMode(P0ENKODER, INPUT);
  pinMode(P1ENKODER, INPUT);

  pinMode(P0MOTOR, OUTPUT);
  pinMode(P1MOTOR, OUTPUT);
  pinMode(L0MOTOR, OUTPUT);
  pinMode(L1MOTOR, OUTPUT);

  pinMode(PCIDLO, INPUT);
  pinMode(LCIDLO, INPUT);

  Serial.begin(9600);

  inicializace();

  pStavMinuly = ctiP0Enkoder();
}

void loop() {
  // put your main code here, to run repeatedly:
  //praveKoloVzad(128);
  ctiP1Enkoder();
//  ctiP1Enkoder();
//  pStav = ctiP0Enkoder();
//  if (pStav != pStavMinuly)
//  {
//    if (ctiP1Enkoder() != pStav)
//    {
//      counter++;
//    }
//    else
//    {
//      counter--;
//    }
//  }
//  pStavMinuly = pStav;
  //Serial.println(ctiP1Enkoder());
  delay(500);
}

//motory
void praveKoloVpred(char vykon)
{
  analogWrite(P0MOTOR, vykon);
  analogWrite(P1MOTOR, 0);
}
void praveKoloVzad(char vykon)
{
  analogWrite(P0MOTOR, 0);
  analogWrite(P1MOTOR, vykon);
}
void leveKoloVpred(char vykon)
{
  analogWrite(L0MOTOR, 0);
  analogWrite(L1MOTOR, vykon);
}
void leveKoloVzad(char vykon)
{
  analogWrite(L0MOTOR, vykon);
  analogWrite(L1MOTOR, 0);
}

//predni cidla
int ctiLeveCidlo()
{
  int hodnota = 0;
  hodnota = analogRead(LCIDLO);
  return hodnota;
}
int ctiPraveCidlo()
{
  int hodnota = 0;
  hodnota = analogRead(PCIDLO);
  return hodnota;
}

//enkoder
int ctiP0Enkoder()
{
  int hodnota = 0;
  hodnota = (100 * ((analogRead(P0ENKODER) - P0MIN) / (P0MAX - P0MIN)));
  if (hodnota > PRAHENKODER)
  {
    return 1;
  }
  else
  {
    return 0;
  }
}
int ctiP1Enkoder()
{
  int hodnota = 0;
  int senzor = analogRead(P1ENKODER);
  Serial.println(senzor);
  Serial.println(P1MIN);
  Serial.println(P1MAX);
  hodnota = ((senzor - P1MIN) / (P1MAX - P1MIN));
  Serial.println(hodnota);
  Serial.println("----------------------");
  if (hodnota > PRAHENKODER)
  {
    return 1;
  }
  else
  {
    return 0;
  }
}
int ctiL0Enkoder()
{
  int hodnota = 0;
  hodnota = 100 * ((analogRead(L0ENKODER) - L0MIN) / (L0MAX - L0MIN));
  if (hodnota > PRAHENKODER)
  {
    return 1;
  }
  else
  {
    return 0;
  }
}
int ctiL1Enkoder()
{
  int hodnota = 0;
  hodnota = 100 * ((analogRead(L1ENKODER) - L1MIN) / (L1MAX - L1MIN));
  if (hodnota > PRAHENKODER)
  {
    return 1;
  }
  else
  {
    return 0;
  }
}

void inicializace()
{
  int hodnota = 0;
  praveKoloVpred(255);
  leveKoloVzad(255);

  for (int i = 0; i < 10000; i++)
  {
    hodnota = analogRead(P0ENKODER);
    if (hodnota > P0MAX)
    {
      P0MAX = hodnota;
    }
    if (hodnota < P0MIN)
    {
      P0MIN = hodnota;
    }

    hodnota = analogRead(P1ENKODER);
    if (hodnota > P1MAX)
    {
      P1MAX = hodnota;
    }
    if (hodnota < P1MIN)
    {
      P1MIN = hodnota;
    }

    hodnota = analogRead(L0ENKODER);
    if (hodnota > L0MAX)
    {
      L0MAX = hodnota;
    }
    if (hodnota < L0MIN)
    {
      L0MIN = hodnota;
    }

    hodnota = analogRead(L1ENKODER);
    if (hodnota > L1MAX)
    {
      L1MAX = hodnota;
    }
    if (hodnota < L1MIN)
    {
      L1MIN = hodnota;
    }
  }
  leveKoloVpred(0);
  praveKoloVpred(0);
}
